恶补费马小定理和组合数

前言:我们平时遇到的组合数如果用杨辉三角型做的话,预处理的复杂度是 n 2 n^2 n2 ,遇到大一点的数据就会爆炸

我们怎么去优化呢
C ( n , k ) = n ! k ! ⋅ ( n − k ) ! m o d    mod C(n, k) = \frac{n!}{k! \cdot (n-k)!} \mod \text{mod} C(n,k)=k!⋅(n−k)!n!modmod

答案太大我们会进行取模,那么我们就可以利用费马小定理

所以我们可以对我们的分母乘积进行逆元操作

但是我们的阶乘进行预处理


我们再来看一下下面这个题目,分析我们得知,只有我们选取的 1 的个数是大于等于 k /2 +1 的,才是有价值的

所以我们可以用组合数的方法进行


题目地址


有一个易错点,我们预处理的时候,阶乘的 a 0 = 1 , 否则会出错


cpp 复制代码
#include<bits/stdc++.h>
using namespace std;

#define int long long
// 1 2 3
const int Mod = (int)1e9 + 7;
int n, k;
const int N = (int)2e5 + 5;
int a[N];

void ini() {
	a[1] = 1; a[0] = 1;
	for (int i = 2; i < N; i++) {
		a[i] = (a[i - 1] * i) % Mod;
	}
}

int qw(int x, int p) {
	int t = 1;
	while (p) {
		if (p & 1) t = (t * x) % Mod;
		x = (x * x) % Mod;
		p >>= 1;
	}
	return t;
}

int C(int n, int k) {
	if (n < k) return 0LL;
	return (a[n] % Mod) * (qw(a[n - k] * a[k] % Mod, Mod - 2) % Mod) % Mod;
}

signed main() {
	int t; ini();
	//for (int i = 1; i <= 10; i++) cout << a[i] << endl;
	//cout << qw(2, 2);
	cin >> t;
	while (t--) {
		cin >> n >> k;
		int one = 0;
		for (int i = 1; i <= n; i++) {
			int u; cin >> u;
			if (u) one++;
		} 
		int ans = 0;
		for (int i = k / 2 + 1; i <= min(one, k); i++) {
			int t = C(one, i) * C(n - one, (k - i)) % Mod;
			ans = (ans + t) % Mod;
		}
		cout << ans << endl;
	}

}
相关推荐
NEFU_Jyj3 小时前
牛客周赛R168
算法
Navigator_Z10 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
D e re k ZH11 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶12 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊12 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
LabVIEW开发14 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔15 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
青少儿编程课堂16 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan17 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构